<template>
  <box :loading="loading">
    <template v-slot:title>Client list</template>

    <div class="w-full flex flex-row justify-end">
      <lull-button type="info" @click="$router.push('/clients/new')">
        New Client
      </lull-button>
    </div>

    <lull-datatable
      class="w-full"
      v-if="data"
      :loading="loading"
      :data="data.items"
      :pageInfo="data.pageInfo"
      :totalCount="data.totalCount"
      :onNext="onNext"
      :onPrevious="onPrevious"
      @update:filterData="setFilterData"
    >
      <lull-datatableColumn
        id="name"
        label="Name"
        :sortable="true"
        :filterable="true"
      />

      <lull-datatableColumn
        id="clientGuid"
        label="Client Id"
        :sortable="true"
        :filterable="true"
      />

      <lull-datatableColumn id="grantType.grantType" label="Grant Type" />

      <lull-datatableColumn
        :width="'25rem'"
        id="actions"
        justifyContent="center"
      >
        <span></span>
      </lull-datatableColumn>

      <template v-slot:actions="{ row }">
        <lull-button
          class="w-0.5"
          type="danger"
          @click="deleteClient(row.clientGuid)"
        >
          <lull-icon icon="fa-trash" />
        </lull-button>

        <lull-button
          class="w-0.5 ml-3"
          type="info"
          @click="$router.push(`/clients/${row.clientGuid}`)"
        >
          <lull-icon icon="fa-edit" />
        </lull-button>
      </template>
    </lull-datatable>

    <confirm
      v-model="confirmationModal"
      :callback="confirmationCallback"
      message="Are you sure you want to permanently delete this client?"
    />
  </box>
</template>

<script lang="ts">
import { Confirm } from '@/core/components';
import { useStore } from '@/store';
import { ClientsAction, ClientsModule } from '@/store/Clients/ClientsModule';
import { DatatableFilterData, useLullToast } from 'lull-ui';
import {
  computed,
  defineComponent,
  onBeforeMount,
  onBeforeUnmount,
  ref,
} from 'vue';

export default defineComponent({
  name: 'clients',
  components: {
    confirm: Confirm,
  },
  setup() {
    const store = useStore();
    const filterData = ref<null | DatatableFilterData>(null);
    const loading = computed(
      () => store.getters['clients/clientsLoadingState']
    );
    const data = computed(() => store.getters['clients/clients']);
    const confirmationModal = ref<boolean>(false);
    const confirmationCallback = ref<Function | undefined>(undefined);
    const toast = useLullToast();

    async function getClients(): Promise<void> {
      await store.dispatch(`clients/${ClientsAction.GetClients}`, {
        filter: filterData.value,
      });
    }

    async function onNext(cursor: string): Promise<void> {
      await store.dispatch(`clients/${ClientsAction.GetClients}`, {
        after: cursor,
        filter: filterData.value,
      });
    }

    async function onPrevious(cursor: string): Promise<void> {
      await store.dispatch(`clients/${ClientsAction.GetClients}`, {
        before: cursor,
        filter: filterData.value,
      });
    }

    async function setFilterData(filter: DatatableFilterData): Promise<void> {
      filterData.value = filter;
      await getClients();
    }

    async function deleteClient(clientId: number) {
      const cb = async (): Promise<void> => {
        await store.dispatch(`clients/${ClientsAction.DeleteClient}`, clientId);
        toast.success({ title: 'Success', message: 'Client deleted.' });
      };

      confirmationCallback.value = cb;
      confirmationModal.value = true;
    }

    onBeforeMount(async () => {
      store.registerModule('clients', ClientsModule);
      await getClients();
    });

    onBeforeUnmount(() => {
      store.unregisterModule('clients');
    });

    return {
      loading,
      data,
      onNext,
      onPrevious,
      setFilterData,
      deleteClient,
      confirmationModal,
      confirmationCallback,
    };
  },
});
</script>